package sudoku;

import java.awt.*;
import java.awt.event.*;

/** un coin entre 4 cellules ... on peut y déposer des marques (candidats) comme avec les cellules
  *<br><i> a corner between 4 cells .. one can put marks inside (candidates) like with cells */

public class Corner extends Zone{

   /** le type de coin ... et il y en a pas mal : coin en périphérie de diagramme, coin en périphérie de section, coin entre 4 sections ...
      *<br><i> corner type ... and the number of types is high : corner at the boundary of the board, corner at the frontier of a section, corner belonging to 4 sections ... */
   public int type;
   static public final int NONE=0;
   static public final int C=0;  // simple cross
   static public final int CC=1; // bold cross (frontiere)
   static public final int LL=2; // lower left
   static public final int UL=3; // upper left
   static public final int LR=4; // lower right
   static public final int UR=5; // upper right
   static public final int LC=6; // bold cross without left part
   static public final int RC=7; // cross without right part
   static public final int CU=8; // cross without upper part
   static public final int CL=9; // cross without lower part
   static public final int cC=10; // only the part in direction j is bold
   static public final int Cc=11; // only the part in direction i is bold
   static public final int Lc=12; // plain cross without left part
   static public final int Rc=13; // plain cross without right part
   static public final int cU=14; // plain cross without upper part
   static public final int cL=15; // plain cross without lower part

/** construire une zone de coin d'un type donné
  * <br><i> building up a cornet zone with a given type */
   public Corner(int s, int t){super(s,s);type=t;}
      
/** dessiner une zone de coin
  * <br><i> drawing a corner zone */
   public void paint(Graphics g){
      int i;
      g.setColor(Color.BLACK);
      if(type==C){
         g.drawLine(size/2-1,0,size/2-1,size-1);
         g.drawLine(0,size/2-1,size-1,size/2-1);
      }else if(type==CC){
         g.drawLine(size/2  ,0,size/2  ,size-1);
         g.drawLine(size/2-1,0,size/2-1,size-1);
         g.drawLine(size/2-2,0,size/2-2,size-1);
         g.drawLine(0,size/2  ,size-1,size/2  );
         g.drawLine(0,size/2-1,size-1,size/2-1);
         g.drawLine(0,size/2-2,size-1,size/2-2);
      }else if(type==CL){
         g.drawLine(size/2  ,0,size/2  ,size/2);
         g.drawLine(size/2-1,0,size/2-1,size/2);
         g.drawLine(size/2-2,0,size/2-2,size/2);
         g.drawLine(0,size/2  ,size-1,size/2  );
         g.drawLine(0,size/2-1,size-1,size/2-1);
         g.drawLine(0,size/2-2,size-1,size/2-2);
      }else if(type==cL){
         g.drawLine(size/2-1,0,size/2-1,size/2);
         g.drawLine(0,size/2  ,size-1,size/2  );
         g.drawLine(0,size/2-1,size-1,size/2-1);
         g.drawLine(0,size/2-2,size-1,size/2-2);
      }else if(type==CU){
         g.drawLine(size/2  ,size/2   ,size/2  ,size-1);
         g.drawLine(size/2-1,size/2   ,size/2-1,size-1);
         g.drawLine(size/2-2,size/2   ,size/2-2,size-1);
         g.drawLine(0,size/2  ,size-1,size/2  );
         g.drawLine(0,size/2-1,size-1,size/2-1);
         g.drawLine(0,size/2-2,size-1,size/2-2);
      }else if(type==cU){
         g.drawLine(size/2-1,size/2   ,size/2-1,size-1);
         g.drawLine(0,size/2  ,size-1,size/2  );
         g.drawLine(0,size/2-1,size-1,size/2-1);
         g.drawLine(0,size/2-2,size-1,size/2-2);
      }else if(type==RC){
         g.drawLine(size/2  ,0,size/2  ,size-1);
         g.drawLine(size/2-1,0,size/2-1,size-1);
         g.drawLine(size/2-2,0,size/2-2,size-1);
         g.drawLine(0,size/2  ,size/2  ,size/2  );
         g.drawLine(0,size/2-1,size/2  ,size/2-1);
         g.drawLine(0,size/2-2,size/2  ,size/2-2);
      }else if(type==Rc){
         g.drawLine(size/2  ,0,size/2  ,size-1);
         g.drawLine(size/2-1,0,size/2-1,size-1);
         g.drawLine(size/2-2,0,size/2-2,size-1);
         g.drawLine(0,size/2-1,size/2  ,size/2-1);
      }else if(type==LC){
         g.drawLine(size/2  ,0,size/2  ,size-1);
         g.drawLine(size/2-1,0,size/2-1,size-1);
         g.drawLine(size/2-2,0,size/2-2,size-1);
         g.drawLine(size/2  ,size/2  ,size-1,size/2  );
         g.drawLine(size/2  ,size/2-1,size-1,size/2-1);
         g.drawLine(size/2  ,size/2-2,size-1,size/2-2);
      }else if(type==Lc){
         g.drawLine(size/2  ,0,size/2  ,size-1);
         g.drawLine(size/2-1,0,size/2-1,size-1);
         g.drawLine(size/2-2,0,size/2-2,size-1);
         g.drawLine(size/2  ,size/2-1,size-1,size/2-1);
      }else if(type==cC){
         g.drawLine(size/2-1,0,size/2-1,size-1);
         g.drawLine(0,size/2  ,size-1,size/2  );
         g.drawLine(0,size/2-1,size-1,size/2-1);
         g.drawLine(0,size/2-2,size-1,size/2-2);
       }else if(type==Cc){
         g.drawLine(size/2  ,0,size/2  ,size-1);
         g.drawLine(size/2-1,0,size/2-1,size-1);
         g.drawLine(size/2-2,0,size/2-2,size-1);
         g.drawLine(0,size/2-1,size-1,size/2-1);
     }else if(type == LL){
         g.drawLine(size/2  ,0,size/2  ,size/2-1);
         g.drawLine(size/2-1,0,size/2-1,size/2-1);
         g.drawLine(size/2-2,0,size/2-2,size/2-1);
         g.drawLine(size/2  ,size/2  ,size-1,size/2  );
         g.drawLine(size/2  ,size/2-1,size-1,size/2-1);
         g.drawLine(size/2  ,size/2-2,size-1,size/2-2);
      }else if(type==LR){
         g.drawLine(0,size/2  ,size/2-1,size/2  );
         g.drawLine(0,size/2-1,size/2-1,size/2-1);
         g.drawLine(0,size/2-2,size/2-1,size/2-2);
         g.drawLine(size/2  ,0,size/2  ,size/2-1);
         g.drawLine(size/2-1,0,size/2-1,size/2-1);
         g.drawLine(size/2-2,0,size/2-2,size/2-1);
      }else if(type == UL){
         g.drawLine(size/2-1,size/2  ,size-1,size/2  );
         g.drawLine(size/2-1,size/2-1,size-1,size/2-1);
         g.drawLine(size/2-1,size/2-2,size-1,size/2-2);
         g.drawLine(size/2  ,size/2-1,size/2  ,size-1);
         g.drawLine(size/2-1,size/2-1,size/2-1,size-1);
         g.drawLine(size/2-2,size/2-1,size/2-2,size-1);
      }else if(type == UR){
         g.drawLine(size/2-1,size/2  ,0,size/2  );
         g.drawLine(size/2-1,size/2-1,0,size/2-1);
         g.drawLine(size/2-1,size/2-2,0,size/2-2);
         g.drawLine(size/2  ,size/2-1,size/2  ,size-1);
         g.drawLine(size/2-1,size/2-1,size/2-1,size-1);
         g.drawLine(size/2-2,size/2-1,size/2-2,size-1);
      }
      drawCandidat(g);
   }
}    
