package sudoku;

import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/**
 * classe gérant les menus définis dans des fichiers de configuration
 * dont chaque suit la forme suivante :
 * <PRE> file_name=titre de la partie ou de la base de données </PRE>
 * <br><i>class managing menus built up from configuration files containing lines as follows :
 * <PRE>file_name=title of the game or of tha data base</PRE> </i>
 */

public class FileList extends Choice{


  /** liste des fichiers référencés dans le menu
      <i>(list of files referenced in the menu)</i>
  */
  Vector files=new Vector();

  public FileList(Applet a){
    int n=0;
    String s;
    while(true){
       s=a.getParameter("file"+n);
       if(s == null) break;
       files.addElement(s);
       addItem(s);
       n++;
    }
  }

  public FileList(String filename,Applet a){
    setFileList(filename,a);
  }

  /** Initialise un menu en lisant un fichier de configuration
      <br><i>(initalize a menu in reading a configuration file)</i>
  */
  public void setFileList(String filename,Applet a){
    BufferedReader br;
    try{
      if(a == null)
        br=new BufferedReader(new FileReader(filename));
      else{
        URL u=new URL(a.getCodeBase(),filename);
        br=new BufferedReader(new InputStreamReader(u.openStream()));
      }
      files.removeAllElements();
      removeAll();
      while(true){
        String line=br.readLine();
        if(line == null) break;
        int equal=line.indexOf('=');
        if(equal != -1){
          addItem(line.substring(equal+1));
          files.addElement(line.substring(0,equal));
        }
      }
    }
    catch(Exception e){
      System.out.println("Impossible to read the file "+filename);
      return;
    }
  }

  /** retourne le nom de fichier correspondant à un indice donné
      <br><i>(returns the file name corresponding to a given index)</i> */
  public String getFile(int index){
    int i=index;
    if(index >= getItemCount()) return null;
    return (String)files.elementAt(i);
  }

  /** retourne le nom de fichier sélectionné par l'utilisateur
      <br><i>(returns the file name selected by the user)</i> */
  public String getFile(){
    return (String)files.elementAt(getSelectedIndex());
  }
}

