package sudoku;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class GameRecorder extends Frame implements WindowListener,ActionListener{

   Board     board;
   TextArea  textarea;
   int currentmove=0;
   int movenumber=0;

   public static void main(String[] a){
      String lang="fr";
      int size=40;
      int red=255;int green=255;int blue=255;
      if(a.length > 1) lang=a[1];
      if(a.length > 2) size=Integer.parseInt(a[2]);
      if(a.length > 3) red=Integer.parseInt(a[3]);
      if(a.length > 4) green=Integer.parseInt(a[4]);
      if(a.length > 5) blue=Integer.parseInt(a[5]);
      GameRecorder gd=new GameRecorder(lang,9,size,new Color(red,green,blue));
   }
      
   public GameRecorder(String lang,int n, int size,Color back){
      
      RF.Init(lang,getClass());
      
      setTitle(RF.get("game.editor"));
      setLayout(new BorderLayout());
      addWindowListener(this);
            
      Panel p=new Panel();
      p.setLayout(new BorderLayout());
      board=new Board(9,size);
      textarea=new TextArea("",5,70);
      p.add("Center",board);p.add("South",textarea);
      add("Center",p);
      
      board.changeBackground(board.position.cells[0][0].back,back);
      
      p=new Panel();
      p.setLayout(new GridLayout(1,4));
      
      Button bloa=new Button(RF.get("game.load"))    ;bloa.addActionListener(this);
      Button bpos=new Button(RF.get("game.position"));bpos.addActionListener(this);
      Button bcom=new Button(RF.get("game.comment")) ;bcom.addActionListener(this);
      Button bsav=new Button(RF.get("game.save"))    ;bsav.addActionListener(this);
      p.add(bloa);p.add(bpos);p.add(bcom);p.add(bsav);
      add("North",p);
      
      p=new Panel();
      p.setLayout(new GridLayout(1,4));
      Button first=new Button("<<")    ;first.addActionListener(this);
      Button prev =new Button("<" )    ; prev.addActionListener(this);
      Button next =new Button(">" )    ; next.addActionListener(this);
      Button last =new Button(">>")    ; last.addActionListener(this);
      p.add(first);p.add(prev);p.add(next);p.add(last);
      add("South",p);
      
      pack();show();
   }
   
   public void actionPerformed(ActionEvent e){
     if(Move.liststring != null){
       if(movenumber != Move.liststring.size()-1){
          movenumber=Move.liststring.size()-1;
          currentmove=movenumber;
       }
     }
     String label=((Button)e.getSource()).getLabel();
     if(label.equals(RF.get("game.position"))){
       Move.emptyRecorder();
       Move.record(Position.saveCandidates(board.position.cells,board.n,board.n,""));
     }else if(label.equals(RF.get("game.comment"))){
       Move.recordComment(textarea.getText(),currentmove);
       textarea.setText("");
     }else if(label.equals(RF.get("game.save"))){
       FileDialog fd=new FileDialog(this,RF.get("game.file"),FileDialog.SAVE);
       fd.show();
       if(fd.getFile() != null) Move.saveRecorder(new File(fd.getDirectory(),fd.getFile()));
     }else if(label.equals(RF.get("game.load"))){
       FileDialog fd=new FileDialog(this,RF.get("game.file"),FileDialog.LOAD);
       fd.show();
       if(fd.getFile() != null) {
          Move.emptyRecorder();
          Move.liststring=Move.readFile(new File(fd.getDirectory(),fd.getFile()));
          System.out.println("number of moves : "+Move.liststring.size());
       }
     }else if(label.equals("<<")){
       currentmove=0;
       setMove(0);
     }else if(label.equals("<")){
       if(currentmove > 0) setMove(--currentmove);
     }else if(label.equals(">")){
       if(currentmove < Move.liststring.size()-1) applyMove(++currentmove);
     }else if(label.equals(">>")){
       currentmove=Move.liststring.size()-1;
       setMove(currentmove);
     }
   }
   
  public void windowActivated(WindowEvent e){}
  public void windowClosing(WindowEvent e){
    Window w=e.getWindow();
    w.dispose();
  }
  public void windowClosed(WindowEvent e){}
  public void windowDeactivated(WindowEvent e){}
  public void windowDeiconified(WindowEvent e){}
  public void windowIconified(WindowEvent e){}
  public void windowOpened(WindowEvent e){}
    
    public void setMove(int i){
      if(i < 0) return;
      board.position.setPosition((String)Move.liststring.get(0));
      for(int k=1; k <= i; k++) applyMove(k);
      currentmove=i;
      board.repaintAll();
    }
    
    public void applyMove(int k){
      String smove=(String)Move.liststring.get(k);
      smove=smove.trim();
      String comment="";
      if(smove.length() > 0) {
         int startcomment=smove.indexOf(' ');
         if(startcomment > 0){ 
            comment=smove.substring(startcomment); 
            smove=smove.substring(0,startcomment);
         }
         Move.executeMove(board,smove);
      }
      textarea.setText(comment);
    }      
    
    public void nextMove(){
      if(currentmove >= Move.liststring.size()-1) return;
      currentmove++;
      applyMove(currentmove);
    }
       
}
