package sudoku;

import java.applet.* ;
import java.net.*;
import java.awt.*;
import java.awt.event.*;

/** un bouton Info pour rappeler quelques informations sur les applets
    <br><i>(a button to recall some useful information about the applets)</i> */

public class Info extends Panel implements ActionListener,WindowListener{

  /** l'applet associée <br><i> the associated applet </i>*/
  public Applet a;
  /** le bouton "info" <br><i> the button "info" </i>*/
  public Button info;
  /** l'adresse du site WEB <br><i> the website address </i>*/
  public Button website;
  /** l'adresse e-mail <br><i> the e-mail address </i>*/
  public Button email;

  /** crée le bouton principal 
    *  <br><i>create the main button</i> */
  public Info(Applet a){
    super();
    this.a=a;
    info=new Button("Applet info");
    this.add(info);
    info.addActionListener(this);
  }

  /** actions à exécuter 
    *  <br><i>actions to execute</i>*/
  public void actionPerformed(ActionEvent ae){
    Button b=(Button)ae.getSource();
    if(b == info){

      Frame f=new Frame("Applet info");
      f.setLayout(new RatioLayout());
      f.addWindowListener(this);

      f.setSize(400,200);
      f.setLocation(200,200);

      Label lauteur=new Label(RF.get("applet.author"));
      Label auteur=new Label("F. Jacq");
      Label lemail=new Label(RF.get("applet.email"));
      email=new Button("francois.jacq@irsn.fr"); email.addActionListener(this);
      Label lwebsite=new Label(RF.get("applet.website"));
      website=new Button("http://parfum-echecs.chez-alice.fr/"); website.addActionListener(this);

      f.add("0.01,0.10",lauteur) ; f.add("0.30,0.10",auteur);
      f.add("0.01,0.30",lemail)  ; f.add("0.30,0.30",email);
      f.add("0.01,0.50",lwebsite); f.add("0.30,0.50",website);
      f.add("0.01,0.70",new Label(RF.get("applet.download")));
      f.add("0.01,0.80",new Label(RF.get("applet.manual")));
      f.show();
    }
    else if(b==email){
      try{
         URL u=new URL("mailto:francois.jacq@irsn.fr");
         a.getAppletContext().showDocument(u);
      }
      catch(Exception e){System.out.println("Invalid e-mail");}
    }
    else if(b==website){
      try{
         URL u=new URL("http://parfum-echecs.chez-alice.fr/");
         a.getAppletContext().showDocument(u);
      }
      catch(Exception e){System.out.println("Invalid web site");}
    }
  }
  public void windowActivated(WindowEvent e){}

  /** fermer la fenêtre dès que l'utilisateur le veut
    * <br><i>(closing the window when the user wants)</i> */
  public void windowClosing(WindowEvent e){
    Window w=e.getWindow();
    w.dispose();
  }
  public void windowClosed(WindowEvent e){}
  public void windowDeactivated(WindowEvent e){}
  public void windowDeiconified(WindowEvent e){}
  public void windowIconified(WindowEvent e){}
  public void windowOpened(WindowEvent e){}
}
 
    
    
