package sudoku;

import java.awt.*;
import java.awt.event.*;

/** une zone rectangulaire, généralement situés entre deux cellule, et utilisée pour recevoir des marques de choix(une variante des candidats)
  * <br><i>a rectangular zone, usually located  between two cells, and used to manage choice marks (variant of candidates)</i>*/

public class Junction extends Zone{

   /** les junctions en frontiere du diagramme sont particulières
     * <br><i> the junctions at the boundary of the board are particular </i> */
   public boolean frontiere;

   public Junction(int width,int height, boolean f){
      super(width,height);
      frontiere=f;
   }
      
   public void paint(Graphics g){
      int i;
      int w=getWidth();
      int h=getHeight();
      g.setColor(Color.BLACK);
      if(w < h){
         g.drawLine(w/2-1,0,w/2-1,h-1);
         if(frontiere){
            g.drawLine(w/2-2,0,w/2-2,h-1);
            g.drawLine(w/2  ,0,w/2  ,h-1);
         }
            
      }else{
         g.drawLine(0,h/2-1,w-1,h/2-1);
         if(frontiere){
            g.drawLine(0,h/2-2,w-1,h/2-2);
            g.drawLine(0,h/2  ,w-1,h/2  );
         }
      }
      drawCandidat(g);
   }
}    
