package sudoku;

import java.util.Vector;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.applet.Applet;


public class Move{

   static Vector liststring;
   
   public static void executeMove(Board b, String m){
      Position p=b.position;
      Zone z[][];
      int pos=0;
      char cc=m.charAt(pos);
      if(cc == 'h'){
         z=p.hjuns;
         pos++;
      }else if(cc == 'v'){
         z=p.vjuns;
         pos++;
      }else if(cc == 'c'){
         z=p.corns;
         pos++;
      }else{
         z=p.cells;
      }
      char   ccol      = m.charAt(pos) ; pos++;
      char   crow      = m.charAt(pos) ; pos++;
      char   operator  = m.charAt(pos) ; pos++;
      String candidat="";
      if(pos < m.length()) candidat  = m.substring(pos,pos+1);
      
      int i=getIndex(ccol);
      int j=getIndex(crow);
      
      if(i < 0 || j < 0) return;
      
      Candidat c=z[i][j].get(candidat);
      
      try{
         switch(operator){
            case  '=' : z[i][j].add(candidat);break;
            case  'x' : c.changeBarre();z[i][j].repaint();break;
            case  's' : z[i][j].delete(candidat);z[i][j].repaint();break;
            case  'd' : z[i][j].clear();z[i][j].repaint();break;
            case  'D' : p.emptyPosition();b.repaintAll();break;
            case  'X' : Algo.fastSolver(p.cells,0);b.repaintAll();break;
            case  'R' : b.selectRow(z[i][j]);break;
            case  'L' : b.selectRow(z[i][j]);break;
            case  'C' : b.selectColumn(z[i][j]);break;
            case  'c' : if(z[i][j] instanceof Cell) p.fillCandidats((Cell)z[i][j],b.position.cells);break;
            case  'S' : b.selectSection(z[i][j]);break;
            case  'Z' : b.selectZone(z[i][j]);break;
            case  'r' : c.setColor(Color.RED);z[i][j].repaint();break;
            case  'g' : c.setColor(Color.GREEN);z[i][j].repaint();break;
            case  'v' : c.setColor(Color.GREEN);z[i][j].repaint();break;
            case  'b' : c.setColor(Color.BLUE);z[i][j].repaint();break;
            case  'n' : c.setColor(Color.BLACK);z[i][j].repaint();break;
            case  '+' : c.setPosition(c.getPosition()+1);z[i][j].repaint();break;
            case  '-' : c.setPosition(c.getPosition()-1);z[i][j].repaint();break;
         }
      }catch(Exception e){System.out.println("invalid move "+m);}      
   }
   
   public static void strong(Board b, String m){
      Position p=b.position;
      Zone z[][];
      int pos=0;
      char cc=m.charAt(pos);
      if(cc == 'h'){
         z=p.hjuns;
         pos++;
      }else if(cc == 'v'){
         z=p.vjuns;
         pos++;
      }else if(cc == 'c'){
         z=p.corns;
         pos++;
      }else{
         z=p.cells;
      }
      char   ccol      = m.charAt(pos) ; pos++;
      char   crow      = m.charAt(pos) ; pos++;
      char f=m.charAt(pos);
      if(f != 'Z') {
        int i=getIndex(ccol);
        int j=getIndex(crow);
        b.selectZone(z[i][j]);
      }
   }
   
   public static void normal(Board b, String m){
      Position p=b.position;
      Zone z[][];
      int pos=0;
      char cc=m.charAt(pos);
      if(cc == 'h'){
         z=p.hjuns;
         pos++;
      }else if(cc == 'v'){
         z=p.vjuns;
         pos++;
      }else if(cc == 'c'){
         z=p.corns;
         pos++;
      }else{
         z=p.cells;
      }
      char   ccol      = m.charAt(pos) ; pos++;
      char   crow      = m.charAt(pos) ; pos++;
      char f=m.charAt(pos);
      if(f != 'Z') {
        int i=getIndex(ccol);
        int j=getIndex(crow);
        b.unselectZone(z[i][j]);
      }
   }
      
   public static int getIndex(char c){
      switch(c){
         case '1' : return 0;
         case '2' : return 1;
         case '3' : return 2;
         case '4' : return 3;
         case '5' : return 4;
         case '6' : return 5;
         case '7' : return 6;
         case '8' : return 7;
         case '9' : return 8;
         case '0' : return 9;
         case 'a' : return 9;
         case 'A' : return 0;
         case 'B' : return 1;
         case 'C' : return 2;
         case 'D' : return 3;
         case 'E' : return 4;
         case 'F' : return 5;
         case 'G' : return 6;
         case 'H' : return 7;
         case 'I' : return 8;
         case 'J' : return 9;
      }
      return -1;
   }
  
   public static int getIndex(String c){return getIndex(c.charAt(0));}
   
   public static String getZoneName(Zone z){
      int i;int j;
      Board b=(Board)z.getParent();
      int n=b.n;
      if(z instanceof Cell){
         for(i=0;i<n;i++)for(j=0;j<n;j++)if(z==b.position.cells[i][j]) return getColumnName(i)+getRowName(j);
      }else if(z instanceof Junction){
         for(i=0;i<=n;i++)for(j=0;j<n;j++)if(z==b.position.hjuns[i][j]) return "h"+getColumnName(i)+getRowName(j);
         for(i=0;i<n;i++)for(j=0;j<=n;j++)if(z==b.position.vjuns[i][j]) return "v"+getColumnName(i)+getRowName(j);
      }else if(z instanceof Corner){
         for(i=0;i<=n;i++)for(j=0;j<=n;j++)if(z==b.position.corns[i][j]) return "c"+getColumnName(i)+getRowName(j);
      }
      return null;
   }
   
   public static String getColumnName(int i){
      switch(i){
         case 0 : return "A";
         case 1 : return "B";
         case 2 : return "C";
         case 3 : return "D";
         case 4 : return "E";
         case 5 : return "F";
         case 6 : return "G";
         case 7 : return "H";
         case 8 : return "I";
         case 9 : return "J";
      }
      return null;
   }
   
   public static String getRowName(int i){
      switch(i){
         case 0 : return "1";
         case 1 : return "2";
         case 2 : return "3";
         case 3 : return "4";
         case 4 : return "5";
         case 5 : return "6";
         case 6 : return "7";
         case 7 : return "8";
         case 8 : return "9";
         case 9 : return "0";
      }
      return null;
   }
   
   public static void record(String s){
      if(s.startsWith("null")) return;
      if(liststring ==  null) liststring=new Vector();
      liststring.add(s);
   }
   
   public static void recordComment(String comment,int i){
      if(liststring ==  null) return;
      String lastmove=(String)liststring.get(i);
      int startcomment=lastmove.indexOf(' ');
      if(startcomment >= 0)
         lastmove=lastmove.substring(0,startcomment)+' '+comment;
      else
         lastmove=lastmove+' '+comment;
      liststring.set(i,lastmove);
   }
   
   public static void saveRecorder(File file){
      if(liststring ==  null) return;
      try{
         BufferedWriter bf=new BufferedWriter(new FileWriter(file));
         for(int i=0; i< liststring.size(); i++){
            bf.write((String)liststring.get(i));
            bf.write('\n');
         }
         bf.close();
      }catch(IOException e){System.out.println("invalid game file "+file.toString());}
   }
   
   public static void emptyRecorder(){
      liststring=null;
   }
    
   public static Vector readFile(String filename,Applet a){
      Vector m=new Vector();
      try{
         URL u=new URL(a.getCodeBase(),filename);
         BufferedReader br=new BufferedReader(new InputStreamReader(u.openStream(),"UTF-8"));
         while(true){
           String line=br.readLine();
           if(line == null) break;
           m.add(line);
         }
      }catch(IOException e){System.out.println("problem with the file "+filename);}
      return m;
   }
    
   public static Vector readFile(File file){
      Vector m=new Vector();
      try{
         BufferedReader br=new BufferedReader(new FileReader(file));
         while(true){
           String line=br.readLine();
           if(line == null) break;
           m.add(line);
         }
      }catch(IOException e){System.out.println("problem with the file "+file.toString());}
      return m;
   }
    
   public static Vector readFile(String filename){return readFile(new File(filename));}
   
}
