package sudoku;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;

/** une applet pour jouer au SU DOKU. Les parties sont enregistrées sous la forme de paramètres d'applet de noms "position0", "position1"  ...
  * <br><i> an applet to play SU DOKU. Games are registered as applet parameters under the names "position0", "position1"  ... </i> */

public class Play extends Applet implements ActionListener{

/** le diagramme de SU DOKU
  * <br><i> the SU DOKU board </i> */
   public Board board;   
/** le nombre de parties
  * <br><i> the number of games </i> */
   public int ngame;
/** le numéro de la partie en cours
  * <br><i> the index of the current game </i> */
   public int currentgame;
/** le bouton pour réinitialiser la position
  * <br><i> the button to restart the current game </i> */
   public Button init;
/** le bouton pour changer de problème
  * <br><i> the button to change the game </i> */
   public Button next;
   
   Random random;

   public void init(){
      int i;
      setBackground(new Color(230,230,230));
      RF.Init(getParameter("lang"),getClass());
      setLayout(new BorderLayout());
      int size=getWidth()/15;
      int red=255;
      int green=255;
      int blue=255;
      board=new Board(9,size);
      if(getParameter(RF.get("red"  )) != null) red  =Integer.parseInt(getParameter(RF.get("red"  )));
      if(getParameter(RF.get("green")) != null) green=Integer.parseInt(getParameter(RF.get("green")));
      if(getParameter(RF.get("blue" )) != null) blue =Integer.parseInt(getParameter(RF.get("blue" )));
      board.changeBackground(board.position.cells[0][0].back,new Color(red,green,blue));
      setFont(new Font("Helvetica",Font.PLAIN,14));
      init=new Button(RF.get("button.init"));
      next=new Button(RF.get("button.next"));
      Panel p=new Panel();
      p.setLayout(new GridLayout(1,2));
      p.add(init);
      p.add(next);
      add("North",p);
      add("Center",board);
      init.addActionListener(this);
      next.addActionListener(this);
      ngame=0;
      while(getParameter(RF.get("position")+ngame) != null) ngame++;
      random=new Random();
      currentgame=random.nextInt(ngame);
      board.position.setPosition(getParameter(RF.get("position")+currentgame));
      board.repaintAll();
    }
    
    public void actionPerformed(ActionEvent e){
      String label=((Button)e.getSource()).getLabel();
      if(label.equals(RF.get("button.init"))){
         board.position.setPosition(getParameter(RF.get("position")+currentgame));
         board.repaintAll();
      }else if(label.equals(RF.get("button.next"))){
         currentgame++;
         if(currentgame == ngame) currentgame=0;
         board.position.setPosition(getParameter(RF.get("position")+currentgame));
         board.repaintAll();
      }
    }
}      
