package sudoku;

import java.awt.*;

/** zone rectangulaire utilisée pour rappeler la numérotation des lignes ou des colonnes
  * <br><i> rectangular zone use to remember the numbering of rows or columns</i> */
  
public class Symbols extends Zone{

   /** la légende à écrire (liste des symboles)
     * <br><i>the legend to draw (list of symbols) </i> */
   public String symbols;
   /** la police utilisée pour écrire la légende
     * <br><i>the font used to draw the legend </i> */
   public Font  font;
   /** écriture dans le sens horizontal ou dans le sens vertical
     * <br><i>writing horizontally or vertically</i> */
   public int   direction;
   /** taille de base d'un symbole
     * <br><i>basic size of a symbol</i> */
   public int   size;

   public Symbols(String s,int width,int height){
      super(width,height);
      if(width > height) {direction=1 ;resize(height);} else {direction=2;resize(width);}
      symbols=s;
   }
   
   public void resize(int size){
      this.size=size;
      font=new Font("Helvetica",Font.BOLD,size*2/3);
   }
   
   public void paint(Graphics g){
     int k;
     setBackground(backmouse);
     g.setFont(font);
     FontMetrics fm=g.getFontMetrics();
     int hfont=fm.getAscent()*7/10;
     g.setColor(Color.RED);
     int x=0;int y=size;
     if(direction == 1){
       for(k=0;k < symbols.length(); k++){
         String s=symbols.substring(k,k+1);
         x=size+k*(size+size/2)-fm.stringWidth(s)/2;
         y=size/5+hfont;
         g.drawString(s,x,y);
       }
     }else{
       for(k=0;k < symbols.length(); k++){
         String s=symbols.substring(k,k+1);
         x=size*4/5-fm.stringWidth(s);
         y=size+k*(size+size/2)+hfont/2;
         g.drawString(s,x,y);
       }
     }
   }
   
}
